
using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;

using ITHit.WebDAV.Server;

namespace WebDAVServer.NtfsStorageAcl
{
    public class MyCustomHandlerPage : Page
    {

        protected System.Web.UI.WebControls.Repeater folderContentGrid;
        protected DavContext context = new DavContext(HttpContext.Current);

        protected MyCustomHandlerPage()
        {
            this.Load += Page_Load;
        }

        void Page_Load(object sender, EventArgs e)
        {
            // While WebDAV interfaces are usually called by DavEngine when request is executed in HttpHandler, 
            // here, for demo purposes, we call them manually to list content of WebDAV folder.
            // You can replace this code and request your storage directly instead of through WebDAV interfaces.
            // Alternatively you can also use the IT Hit WebDAV Ajax Library in client-side JavaScript to list 
            // WebDAV server content. Use HttpListener wisard or HttpListener sample provided with SDK for sample Ajax code.
            HttpRequest request = HttpContext.Current.Request;
            string relativePath = request.RawUrl.Substring(request.ApplicationPath.Length);
            DavFolder folder = (DavFolder)context.GetHierarchyItem(relativePath);
            IEnumerable<IHierarchyItem> children = folder.GetChildren(null);

            folderContentGrid.DataSource = children;
            folderContentGrid.DataBind();
        }
    }
}