﻿//!<#@ template language="C#" #>
//!<#@ samplevars Processor="DirectiveProcessor" #>
//!<# if (!Params.CalDav && !Params.CardDav)  return string.Empty; #>
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

using ITHit.WebDAV.Server;
//!<# if (Params.CalDav) { #>
using ITHit.WebDAV.Server.CalDav;
//!<# } #>
//!<# if (Params.CardDav) { #>
using ITHit.WebDAV.Server.CardDav;
//!<# } #>

//!<# if (Params.CalDav) { #>
using ITHit.WebDav.Server.SampleModel.__NtfsStorage__.CalDav;
//!<# } #>
//!<# if (Params.CardDav) { #>
using ITHit.WebDav.Server.SampleModel.__NtfsStorage__.CardDav;
//!<# } #>
//!<# if (false) { #>
using ITHit.WebDav.Server.SampleModel.__NtfsStorage__;
//!<# } #>


namespace ITHit.WebDav.Server.SampleModel
{
    /// <summary>
    /// Assists in finding folders that contain calendars and addressbooks.
    /// </summary>
    public class Discovery :
        /*!<# if (Params.CalDav) { #>!*/ ICalendarDiscovery/*!<# } #>!*/
        /*!<# if (Params.CalDav && Params.CardDav) { #>!*/ ,/*!<# } #>!*//*!<# if (Params.CardDav) { #>!*/ IAddressbookDiscovery/*!<# } #>!*/
    {
        /// <summary>
        /// Instance of <see cref="DavContext"/>.
        /// </summary>
        private DavContext context;

        public Discovery(DavContext context)
        {
            this.context = context;
        }
        //!<# if (Params.CalDav) { #>

        /// <summary>
        /// Returns list of folders that contain calendars owned by this principal.
        /// </summary>
        /// <remarks>This enables calendars discovery owned by current loged-in principal.</remarks>
        public IEnumerable<IItemCollection> CalendarHomeSet
        {
            get
            {
                string calendarsUserFolder = string.Format("{0}/{1}/", CalendarsRootFolder.CalendarsRootFolderName, context.UserName);
                yield return DavFolder.GetFolder(context, calendarsUserFolder);
            }
        }
        //!<# } #>
        //!<# if (Params.CardDav) { #>

        /// <summary>
        /// Returns list of folders that contain addressbooks owned by this principal.
        /// </summary>
        /// <remarks>This enables addressbooks discovery owned by current loged-in principal.</remarks>
        public IEnumerable<IItemCollection> AddressbookHomeSet
        {
            get
            {
                string addressbooksUserFolder = string.Format("{0}/{1}/", AddressbooksRootFolder.AddressbooksRootFolderName, context.UserName);
                yield return DavFolder.GetFolder(context, addressbooksUserFolder);
            }
        }
        //!<# } #>
    }
}