﻿//!<#@ template language="C#" #>
//!<#@ samplevars Processor="DirectiveProcessor" #>
//!<# if (!Params.AddCustomGetHandler || (Params.Hosting != HostingEnvironment.IIS))  return string.Empty; #>

using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;

using ITHit.WebDAV.Server;
//!<# if (Params.CalDav) { #>
using ITHit.WebDAV.Server.CalDav;
//!<# } #>
//!<# if (Params.CardDav) { #>
using ITHit.WebDAV.Server.CardDav;
//!<# } #>
//!<# if (false) { #>
// only required to compile project at dev time
using ITHit.WebDav.Server.SampleModel.__NtfsStorage__;
//!<# } #>

namespace ITHit.WebDav.Server.SampleModel
{
    public class MyCustomHandlerPage : Page
    {
        //!<# if (!Params.CalDav && !Params.CardDav) { #>

        protected System.Web.UI.WebControls.Repeater folderContentGrid;
        protected DavContext context = new DavContext(HttpContext.Current);

        protected MyCustomHandlerPage()
        {
            this.Load += Page_Load;
        }

        void Page_Load(object sender, EventArgs e)
        {
            // While WebDAV interfaces are usually called by DavEngine when request is executed in HttpHandler, 
            // here, for demo purposes, we call them manually to list content of WebDAV folder.
            // You can replace this code and request your storage directly instead of through WebDAV interfaces.
            // Alternatively you can also use the IT Hit WebDAV Ajax Library in client-side JavaScript to list 
            // WebDAV server content. Use HttpListener wisard or HttpListener sample provided with SDK for sample Ajax code.
            HttpRequest request = HttpContext.Current.Request;
            string relativePath = request.RawUrl.Substring(request.ApplicationPath.Length);
            DavFolder folder = (DavFolder)context.GetHierarchyItem(relativePath);
            IEnumerable<IHierarchyItem> children = folder.GetChildren(null);

            folderContentGrid.DataSource = children;
            folderContentGrid.DataBind();
        }
        //!<# } #>
        //!<# if (Params.CalDav || Params.CardDav) { #>

        private Discovery discovery = new Discovery(new DavContext(HttpContext.Current));
        //!<# } #>
        //!<# if (Params.CalDav) { #>

        /// <summary>
        /// Gets all user calendars Urls
        /// </summary>
        public IEnumerable<string> AllUserCalendarsUrl
        {
            get 
            {
                List<string> urls = new List<string>();                
                
                // get list of folders that contain user calendars and enumerate calendars in each folder
                foreach (IItemCollection folder in discovery.CalendarHomeSet)
                {
                    IEnumerable<IHierarchyItem> children = folder.GetChildren(new PropertyName[0]);
                    foreach (IHierarchyItem item in children)
                    {
                        if (item is ICalendarFolder)
                        {
                            urls.Add(ApplicationPath + item.Path);
                        }
                    }
                }
                return urls;
            }
        }
        //!<# } #>
        //!<# if (Params.CardDav) { #>

        /// <summary>
        /// Gets all user addressbooks Urls
        /// </summary>
        public IEnumerable<string> AllUserAddressbooksUrl
        {
            get
            {
                List<string> urls = new List<string>();

                // get list of folders that contain user addressbooks and enumerate calendars in each folder
                foreach (IItemCollection folder in discovery.AddressbookHomeSet)
                {
                    IEnumerable<IHierarchyItem> children = folder.GetChildren(new PropertyName[0]);
                    foreach (IHierarchyItem item in children)
                    {
                        if (item is IAddressbookFolder)
                        {
                            urls.Add(ApplicationPath + item.Path);
                        }
                    }
                }
                return urls;
            }
        }
        //!<# } #>
        //!<# if (Params.CalDav || Params.CardDav) { #>

        public static string ApplicationPath
        {
            get
            {
                Uri url = HttpContext.Current.Request.Url;
                DavContext context = new DavContext(HttpContext.Current);
                string server = url.Scheme + "://" + url.Host + (url.IsDefaultPort ? "" : ":"+url.Port.ToString()) + "/" + context.Request.ApplicationPath.Trim('/');
                return server.TrimEnd('/') + '/';
            }
        }
        //!<# } #>
    }
}