﻿//!<#@ template language="C#" #>
//!<#@ samplevars Processor="DirectiveProcessor" #>
//!<# if (!Params.CalDav)  return string.Empty; #>
//!<# if (Params.Storage != StorageType.Ntfs)  return string.Empty; #>
using System;
using System.IO;
using System.Linq;

using ITHit.WebDAV.Server;

namespace ITHit.WebDav.Server.SampleModel.__NtfsStorage__.CalDav
{
    public static class CalDavFactory
    {
        /// <summary>
        /// Gets CalDAV items.
        /// </summary>
        /// <param name="path">Relative path requested.</param>
        /// <param name="context">Instance of <see cref="DavContext"/> class.</param>
        /// <returns>Object implementing various calendar items or null if no object corresponding to path is found.</returns>
        public static IHierarchyItem GetCalDavItem(DavContext context, string path)
        {
            IHierarchyItem item = null;

            item = CalendarsRootFolder.GetCalendarsRootFolder(context, path);
            if (item != null)
                return item;

            item = ScheduleOutboxFolder.GetScheduleOutboxFolder(context, path);
            if (item != null)
                return item;

            item = ScheduleInboxFolder.GetScheduleInboxFolder(context, path);
            if (item != null)
                return item;

            item = CalendarFolder.GetCalendarFolder(context, path);
            if (item != null)
                return item;

            item = CalendarFile.GetCalendarFile(context, path);
            if (item != null)
                return item;

            return null;
        }
    }
}